Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 4130)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 4131)
@@ -9662,408 +9854,404 @@
     IF ( mode == 'allocate' )  THEN
 
-       SELECT CASE ( TRIM( variable ) )
-
-          CASE ( 'g_H2SO4' )
-             IF ( .NOT. ALLOCATED( g_h2so4_av ) )  THEN
-                ALLOCATE( g_h2so4_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             g_h2so4_av = 0.0_wp
-
-          CASE ( 'g_HNO3' )
-             IF ( .NOT. ALLOCATED( g_hno3_av ) )  THEN
-                ALLOCATE( g_hno3_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             g_hno3_av = 0.0_wp
-
-          CASE ( 'g_NH3' )
-             IF ( .NOT. ALLOCATED( g_nh3_av ) )  THEN
-                ALLOCATE( g_nh3_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             g_nh3_av = 0.0_wp
-
-          CASE ( 'g_OCNV' )
-             IF ( .NOT. ALLOCATED( g_ocnv_av ) )  THEN
-                ALLOCATE( g_ocnv_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             g_ocnv_av = 0.0_wp
-
-          CASE ( 'g_OCSV' )
-             IF ( .NOT. ALLOCATED( g_ocsv_av ) )  THEN
-                ALLOCATE( g_ocsv_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             g_ocsv_av = 0.0_wp
-
-          CASE ( 'LDSA' )
-             IF ( .NOT. ALLOCATED( ldsa_av ) )  THEN
-                ALLOCATE( ldsa_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             ldsa_av = 0.0_wp
-
-          CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4', 'N_bin5', 'N_bin6', 'N_bin7', 'N_bin8',   &
-                 'N_bin9', 'N_bin10', 'N_bin11', 'N_bin12' )
-             IF ( .NOT. ALLOCATED( nbins_av ) )  THEN
-                ALLOCATE( nbins_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol) )
-             ENDIF
-             nbins_av = 0.0_wp
-
-          CASE ( 'Ntot' )
-             IF ( .NOT. ALLOCATED( ntot_av ) )  THEN
-                ALLOCATE( ntot_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             ntot_av = 0.0_wp
-
-          CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4', 'm_bin5', 'm_bin6', 'm_bin7', 'm_bin8',   &
-                 'm_bin9', 'm_bin10', 'm_bin11', 'm_bin12' )
-             IF ( .NOT. ALLOCATED( mbins_av ) )  THEN
-                ALLOCATE( mbins_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol) )
-             ENDIF
-             mbins_av = 0.0_wp
-
-          CASE ( 'PM2.5' )
-             IF ( .NOT. ALLOCATED( pm25_av ) )  THEN
-                ALLOCATE( pm25_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             pm25_av = 0.0_wp
-
-          CASE ( 'PM10' )
-             IF ( .NOT. ALLOCATED( pm10_av ) )  THEN
-                ALLOCATE( pm10_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             pm10_av = 0.0_wp
-
-          CASE ( 's_BC' )
-             IF ( .NOT. ALLOCATED( s_bc_av ) )  THEN
-                ALLOCATE( s_bc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             s_bc_av = 0.0_wp
-
-          CASE ( 's_DU' )
-             IF ( .NOT. ALLOCATED( s_du_av ) )  THEN
-                ALLOCATE( s_du_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             s_du_av = 0.0_wp
-
-          CASE ( 's_H2O' )
-             IF ( .NOT. ALLOCATED( s_h2o_av ) )  THEN
-                ALLOCATE( s_h2o_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             s_h2o_av = 0.0_wp
-
-          CASE ( 's_NH' )
-             IF ( .NOT. ALLOCATED( s_nh_av ) )  THEN
-                ALLOCATE( s_nh_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             s_nh_av = 0.0_wp
-
-          CASE ( 's_NO' )
-             IF ( .NOT. ALLOCATED( s_no_av ) )  THEN
-                ALLOCATE( s_no_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             s_no_av = 0.0_wp
-
-          CASE ( 's_OC' )
-             IF ( .NOT. ALLOCATED( s_oc_av ) )  THEN
-                ALLOCATE( s_oc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             s_oc_av = 0.0_wp
-
-          CASE ( 's_SO4' )
-             IF ( .NOT. ALLOCATED( s_so4_av ) )  THEN
-                ALLOCATE( s_so4_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             s_so4_av = 0.0_wp   
-
-          CASE ( 's_SS' )
-             IF ( .NOT. ALLOCATED( s_ss_av ) )  THEN
-                ALLOCATE( s_ss_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             ENDIF
-             s_ss_av = 0.0_wp
-
-          CASE DEFAULT
-             CONTINUE
-
-       END SELECT
+       IF ( variable(7:11) ==  'N_bin' )  THEN
+          IF ( .NOT. ALLOCATED( nbins_av ) )  THEN
+             ALLOCATE( nbins_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol) )
+          ENDIF
+          nbins_av = 0.0_wp
+
+       ELSEIF ( variable(7:11) ==  'm_bin' )  THEN
+          IF ( .NOT. ALLOCATED( mbins_av ) )  THEN
+             ALLOCATE( mbins_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol) )
+          ENDIF
+          mbins_av = 0.0_wp
+
+       ELSE
+
+          SELECT CASE ( TRIM( variable(7:) ) )
+
+             CASE ( 'g_H2SO4' )
+                IF ( .NOT. ALLOCATED( g_h2so4_av ) )  THEN
+                   ALLOCATE( g_h2so4_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                g_h2so4_av = 0.0_wp
+
+             CASE ( 'g_HNO3' )
+                IF ( .NOT. ALLOCATED( g_hno3_av ) )  THEN
+                   ALLOCATE( g_hno3_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                g_hno3_av = 0.0_wp
+
+             CASE ( 'g_NH3' )
+                IF ( .NOT. ALLOCATED( g_nh3_av ) )  THEN
+                   ALLOCATE( g_nh3_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                g_nh3_av = 0.0_wp
+
+             CASE ( 'g_OCNV' )
+                IF ( .NOT. ALLOCATED( g_ocnv_av ) )  THEN
+                   ALLOCATE( g_ocnv_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                g_ocnv_av = 0.0_wp
+
+             CASE ( 'g_OCSV' )
+                IF ( .NOT. ALLOCATED( g_ocsv_av ) )  THEN
+                   ALLOCATE( g_ocsv_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                g_ocsv_av = 0.0_wp
+
+             CASE ( 'LDSA' )
+                IF ( .NOT. ALLOCATED( ldsa_av ) )  THEN
+                   ALLOCATE( ldsa_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                ldsa_av = 0.0_wp
+
+             CASE ( 'N_UFP' )
+                IF ( .NOT. ALLOCATED( nufp_av ) )  THEN
+                   ALLOCATE( nufp_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                nufp_av = 0.0_wp
+
+             CASE ( 'Ntot' )
+                IF ( .NOT. ALLOCATED( ntot_av ) )  THEN
+                   ALLOCATE( ntot_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                ntot_av = 0.0_wp
+
+             CASE ( 'PM0.1' )
+                IF ( .NOT. ALLOCATED( pm01_av ) )  THEN
+                   ALLOCATE( pm01_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                pm01_av = 0.0_wp
+
+             CASE ( 'PM2.5' )
+                IF ( .NOT. ALLOCATED( pm25_av ) )  THEN
+                   ALLOCATE( pm25_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                pm25_av = 0.0_wp
+
+             CASE ( 'PM10' )
+                IF ( .NOT. ALLOCATED( pm10_av ) )  THEN
+                   ALLOCATE( pm10_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                pm10_av = 0.0_wp
+
+             CASE ( 's_BC' )
+                IF ( .NOT. ALLOCATED( s_bc_av ) )  THEN
+                   ALLOCATE( s_bc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                s_bc_av = 0.0_wp
+
+             CASE ( 's_DU' )
+                IF ( .NOT. ALLOCATED( s_du_av ) )  THEN
+                   ALLOCATE( s_du_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                s_du_av = 0.0_wp
+
+             CASE ( 's_H2O' )
+                IF ( .NOT. ALLOCATED( s_h2o_av ) )  THEN
+                   ALLOCATE( s_h2o_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                s_h2o_av = 0.0_wp
+
+             CASE ( 's_NH' )
+                IF ( .NOT. ALLOCATED( s_nh_av ) )  THEN
+                   ALLOCATE( s_nh_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                s_nh_av = 0.0_wp
+
+             CASE ( 's_NO' )
+                IF ( .NOT. ALLOCATED( s_no_av ) )  THEN
+                   ALLOCATE( s_no_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                s_no_av = 0.0_wp
+
+             CASE ( 's_OC' )
+                IF ( .NOT. ALLOCATED( s_oc_av ) )  THEN
+                   ALLOCATE( s_oc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                s_oc_av = 0.0_wp
+
+             CASE ( 's_SO4' )
+                IF ( .NOT. ALLOCATED( s_so4_av ) )  THEN
+                   ALLOCATE( s_so4_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                s_so4_av = 0.0_wp
+
+             CASE ( 's_SS' )
+                IF ( .NOT. ALLOCATED( s_ss_av ) )  THEN
+                   ALLOCATE( s_ss_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                s_ss_av = 0.0_wp
+
+             CASE DEFAULT
+                CONTINUE
+
+          END SELECT
+
+       ENDIF
 
     ELSEIF ( mode == 'sum' )  THEN
 
-       SELECT CASE ( TRIM( variable ) )
-
-          CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV', 'g_OCSV' )
-
-             vari = TRIM( variable(3:) )
-
-             SELECT CASE( vari )
-
-                CASE( 'H2SO4' )
-                   found_index = 1
-                   to_be_resorted => g_h2so4_av
-
-                CASE( 'HNO3' )
-                   found_index = 2
-                   to_be_resorted => g_hno3_av
-
-                CASE( 'NH3' )
-                   found_index = 3
-                   to_be_resorted => g_nh3_av
-
-                CASE( 'OCNV' )
-                   found_index = 4
-                   to_be_resorted => g_ocnv_av
-
-                CASE( 'OCSN' )
-                   found_index = 5
-                   to_be_resorted => g_ocsv_av
-
-             END SELECT
-
+       IF ( variable(7:11) ==  'N_bin' )  THEN
+          READ( variable(12:),* ) char_to_int
+          IF ( char_to_int >= 1  .AND. char_to_int <= SUM( nbin ) )  THEN
+             ib = char_to_int
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      to_be_resorted(k,j,i) = to_be_resorted(k,j,i) +                              &
-                                              salsa_gas(found_index)%conc(k,j,i)
+                      nbins_av(k,j,i,ib) = nbins_av(k,j,i,ib) + aerosol_number(ib)%conc(k,j,i)
                    ENDDO
                 ENDDO
              ENDDO
-
-          CASE ( 'LDSA' )
+          ENDIF
+
+       ELSEIF ( variable(7:11) ==  'm_bin' )  THEN
+          READ( variable(12:),* ) char_to_int
+          IF ( char_to_int >= 1  .AND. char_to_int <= SUM( nbin ) )  THEN
+             ib = char_to_int
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-!
-!--                      Diameter in micrometres
-                         mean_d = 1.0E+6_wp * ra_dry(k,j,i,ib) * 2.0_wp
-!
-!--                      Deposition factor: alveolar (use ra_dry)
-                         df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp * ( LOG( mean_d ) +       &
-                                2.84_wp )**2 ) + 19.11_wp * EXP( -0.482_wp * ( LOG( mean_d ) -     &
-                                1.362_wp )**2 ) )
-!
-!--                      Number concentration in 1/cm3
-                         nc = 1.0E-6_wp * aerosol_number(ib)%conc(k,j,i)
-!
-!--                      Lung-deposited surface area LDSA (units mum2/cm3)
-                         temp_bin = temp_bin + pi * mean_d**2 * df * nc
+                      DO  ic = ib, nbins_aerosol * ncomponents_mass, nbins_aerosol
+                         temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
                       ENDDO
-                      ldsa_av(k,j,i) = ldsa_av(k,j,i) + temp_bin
+                      mbins_av(k,j,i,ib) = mbins_av(k,j,i,ib) + temp_bin
                    ENDDO
                 ENDDO
              ENDDO
-
-          CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4', 'N_bin5', 'N_bin6', 'N_bin7', 'N_bin8',   &
-                 'N_bin9', 'N_bin10', 'N_bin11', 'N_bin12' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      DO  ib = 1, nbins_aerosol
-                         nbins_av(k,j,i,ib) = nbins_av(k,j,i,ib) + aerosol_number(ib)%conc(k,j,i)
+          ENDIF
+       ELSE
+
+          SELECT CASE ( TRIM( variable(7:) ) )
+
+             CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV', 'g_OCSV' )
+
+                vari = TRIM( variable(9:) )  ! remove salsa_g_ from beginning
+
+                SELECT CASE( vari )
+
+                   CASE( 'H2SO4' )
+                      found_index = 1
+                      to_be_resorted => g_h2so4_av
+
+                   CASE( 'HNO3' )
+                      found_index = 2
+                      to_be_resorted => g_hno3_av
+
+                   CASE( 'NH3' )
+                      found_index = 3
+                      to_be_resorted => g_nh3_av
+
+                   CASE( 'OCNV' )
+                      found_index = 4
+                      to_be_resorted => g_ocnv_av
+
+                   CASE( 'OCSV' )
+                      found_index = 5
+                      to_be_resorted => g_ocsv_av
+
+                END SELECT
+
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         to_be_resorted(k,j,i) = to_be_resorted(k,j,i) +                           &
+                                                 salsa_gas(found_index)%conc(k,j,i)
                       ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
-
-          CASE ( 'Ntot' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      DO  ib = 1, nbins_aerosol
-                         ntot_av(k,j,i) = ntot_av(k,j,i) + aerosol_number(ib)%conc(k,j,i)
+
+             CASE ( 'LDSA' )
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+   !
+   !--                      Diameter in micrometres
+                            mean_d = 1.0E+6_wp * ra_dry(k,j,i,ib) * 2.0_wp
+   !
+   !--                      Deposition factor: alveolar (use ra_dry)
+                            df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp * ( LOG( mean_d ) +    &
+                                   2.84_wp )**2 ) + 19.11_wp * EXP( -0.482_wp * ( LOG( mean_d ) -  &
+                                   1.362_wp )**2 ) )
+   !
+   !--                      Lung-deposited surface area LDSA (units mum2/cm3)
+                            temp_bin = temp_bin + pi * mean_d**2 * df * 1.0E-6_wp *                &
+                                       aerosol_number(ib)%conc(k,j,i)
+                         ENDDO
+                         ldsa_av(k,j,i) = ldsa_av(k,j,i) + temp_bin
                       ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
-
-          CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4', 'm_bin5', 'm_bin6', 'm_bin7', 'm_bin8',   &
-                 'm_bin9', 'm_bin10', 'm_bin11', 'm_bin12' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      DO  ib = 1, nbins_aerosol
-                         DO  ic = ib, nbins_aerosol * ncomponents_mass, nbins_aerosol
-                            mbins_av(k,j,i,ib) = mbins_av(k,j,i,ib) + aerosol_mass(ic)%conc(k,j,i)
+
+             CASE ( 'N_UFP' )
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 0.1E-6_wp )  THEN
+                               temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
+                            ENDIF
+                         ENDDO
+                         nufp_av(k,j,i) = nufp_av(k,j,i) + temp_bin
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+             CASE ( 'Ntot' )
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         DO  ib = 1, nbins_aerosol
+                            ntot_av(k,j,i) = ntot_av(k,j,i) + aerosol_number(ib)%conc(k,j,i)
                          ENDDO
                       ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
-
-          CASE ( 'PM2.5' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 2.5E-6_wp )  THEN
-                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
-                               temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
-                            ENDDO
-                         ENDIF
+
+             CASE ( 'PM0.1' )
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 0.1E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         pm01_av(k,j,i) = pm01_av(k,j,i) + temp_bin
                       ENDDO
-                      pm25_av(k,j,i) = pm25_av(k,j,i) + temp_bin
                    ENDDO
                 ENDDO
-             ENDDO
-
-          CASE ( 'PM10' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 10.0E-6_wp )  THEN
-                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
-                               temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
-                            ENDDO
-                         ENDIF
+
+             CASE ( 'PM2.5' )
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 2.5E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         pm25_av(k,j,i) = pm25_av(k,j,i) + temp_bin
                       ENDDO
-                      pm10_av(k,j,i) = pm10_av(k,j,i) + temp_bin
                    ENDDO
                 ENDDO
-             ENDDO
-
-          CASE ( 's_BC', 's_DU', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
-             IF ( is_used( prtcl, TRIM( variable(3:) ) ) )  THEN
-                found_index = get_index( prtcl, TRIM( variable(3:) ) )
-                IF ( TRIM( variable(3:) ) == 'BC' )   to_be_resorted => s_bc_av
-                IF ( TRIM( variable(3:) ) == 'DU' )   to_be_resorted => s_du_av
-                IF ( TRIM( variable(3:) ) == 'NH' )   to_be_resorted => s_nh_av
-                IF ( TRIM( variable(3:) ) == 'NO' )   to_be_resorted => s_no_av
-                IF ( TRIM( variable(3:) ) == 'OC' )   to_be_resorted => s_oc_av
-                IF ( TRIM( variable(3:) ) == 'SO4' )  to_be_resorted => s_so4_av
-                IF ( TRIM( variable(3:) ) == 'SS' )   to_be_resorted => s_ss_av
+
+             CASE ( 'PM10' )
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 10.0E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         pm10_av(k,j,i) = pm10_av(k,j,i) + temp_bin
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+             CASE ( 's_BC', 's_DU', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
+                IF ( is_used( prtcl, TRIM( variable(9:) ) ) )  THEN  ! 9: remove salsa_s_
+                   found_index = get_index( prtcl, TRIM( variable(9:) ) )
+                   IF ( TRIM( variable(9:) ) == 'BC' )   to_be_resorted => s_bc_av
+                   IF ( TRIM( variable(9:) ) == 'DU' )   to_be_resorted => s_du_av
+                   IF ( TRIM( variable(9:) ) == 'NH' )   to_be_resorted => s_nh_av
+                   IF ( TRIM( variable(9:) ) == 'NO' )   to_be_resorted => s_no_av
+                   IF ( TRIM( variable(9:) ) == 'OC' )   to_be_resorted => s_oc_av
+                   IF ( TRIM( variable(9:) ) == 'SO4' )  to_be_resorted => s_so4_av
+                   IF ( TRIM( variable(9:) ) == 'SS' )   to_be_resorted => s_ss_av
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         DO  k = nzb, nzt+1
+                            DO  ic = ( found_index-1 ) * nbins_aerosol + 1, found_index * nbins_aerosol
+                               to_be_resorted(k,j,i) = to_be_resorted(k,j,i) +                     &
+                                                       aerosol_mass(ic)%conc(k,j,i)
+                            ENDDO
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ENDIF
+
+             CASE ( 's_H2O' )
+                found_index = get_index( prtcl,'H2O' )
+                to_be_resorted => s_h2o_av
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
                       DO  k = nzb, nzt+1
                          DO  ic = ( found_index-1 ) * nbins_aerosol + 1, found_index * nbins_aerosol
-                            to_be_resorted(k,j,i) = to_be_resorted(k,j,i) +                        &
-                                                    aerosol_mass(ic)%conc(k,j,i)
+                            s_h2o_av(k,j,i) = s_h2o_av(k,j,i) + aerosol_mass(ic)%conc(k,j,i)
                          ENDDO
                       ENDDO
                    ENDDO
                 ENDDO
-             ENDIF
-
-          CASE ( 's_H2O' )
-             found_index = get_index( prtcl,'H2O' )
-             to_be_resorted => s_h2o_av
+
+             CASE DEFAULT
+                CONTINUE
+
+          END SELECT
+
+       ENDIF
+
+    ELSEIF ( mode == 'average' )  THEN
+
+       IF ( variable(7:11) ==  'N_bin' )  THEN
+          READ( variable(12:),* ) char_to_int
+          IF ( char_to_int >= 1  .AND. char_to_int <= SUM( nbin ) )  THEN
+             ib = char_to_int
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      DO  ic = ( found_index-1 ) * nbins_aerosol + 1, found_index * nbins_aerosol
-                         to_be_resorted(k,j,i) = to_be_resorted(k,j,i) +                           &
-                                                 aerosol_mass(ic)%conc(k,j,i)
-                      ENDDO
+                      nbins_av(k,j,i,ib) = nbins_av(k,j,i,ib) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
              ENDDO
-
-          CASE DEFAULT
-             CONTINUE
-
-       END SELECT
-
-    ELSEIF ( mode == 'average' )  THEN
-
-       SELECT CASE ( TRIM( variable ) )
-
-          CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV', 'g_OCSV' )
-             IF ( TRIM( variable(3:) ) == 'H2SO4' )  THEN
-                found_index = 1
-                to_be_resorted => g_h2so4_av
-             ELSEIF ( TRIM( variable(3:) ) == 'HNO3' )  THEN
-                found_index = 2
-                to_be_resorted => g_hno3_av
-             ELSEIF ( TRIM( variable(3:) ) == 'NH3' )  THEN
-                found_index = 3
-                to_be_resorted => g_nh3_av
-             ELSEIF ( TRIM( variable(3:) ) == 'OCNV' )  THEN
-                found_index = 4
-                to_be_resorted => g_ocnv_av
-             ELSEIF ( TRIM( variable(3:) ) == 'OCSV' )  THEN
-                found_index = 5
-                to_be_resorted => g_ocsv_av
-             ENDIF
+          ENDIF
+
+       ELSEIF ( variable(7:11) ==  'm_bin' )  THEN
+          READ( variable(12:),* ) char_to_int
+          IF ( char_to_int >= 1  .AND. char_to_int <= SUM( nbin ) )  THEN
+             ib = char_to_int
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      to_be_resorted(k,j,i) = to_be_resorted(k,j,i) /                              &
-                                              REAL( average_count_3d, KIND=wp )
+                      mbins_av(k,j,i,ib) = mbins_av(k,j,i,ib) / REAL( average_count_3d, KIND=wp)
                    ENDDO
                 ENDDO
              ENDDO
-
-          CASE ( 'LDSA' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      ldsa_av(k,j,i) = ldsa_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4', 'N_bin5', 'N_bin6', 'N_bin7', 'N_bin8',   &
-                 'N_bin9', 'N_bin10', 'N_bin11', 'N_bin12' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      DO  ib = 1, nbins_aerosol
-                         nbins_av(k,j,i,ib) = nbins_av(k,j,i,ib) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 'Ntot' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      ntot_av(k,j,i) = ntot_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4', 'm_bin5', 'm_bin6', 'm_bin7', 'm_bin8',   &
-                 'm_bin9', 'm_bin10', 'm_bin11', 'm_bin12' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      DO  ib = 1, nbins_aerosol
-                         DO  ic = ib, nbins_aerosol * ncomponents_mass, nbins_aerosol
-                            mbins_av(k,j,i,ib) = mbins_av(k,j,i,ib) /                              &
-                                                 REAL( average_count_3d, KIND=wp)
-                         ENDDO
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 'PM2.5' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      pm25_av(k,j,i) = pm25_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 'PM10' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      pm10_av(k,j,i) = pm10_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 's_BC', 's_DU', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
-             IF ( is_used( prtcl, TRIM( variable(3:) ) ) )  THEN
-                IF ( TRIM( variable(3:) ) == 'BC' )   to_be_resorted => s_bc_av
-                IF ( TRIM( variable(3:) ) == 'DU' )   to_be_resorted => s_du_av
-                IF ( TRIM( variable(3:) ) == 'NH' )   to_be_resorted => s_nh_av
-                IF ( TRIM( variable(3:) ) == 'NO' )   to_be_resorted => s_no_av
-                IF ( TRIM( variable(3:) ) == 'OC' )   to_be_resorted => s_oc_av
-                IF ( TRIM( variable(3:) ) == 'SO4' )  to_be_resorted => s_so4_av
-                IF ( TRIM( variable(3:) ) == 'SS' )   to_be_resorted => s_ss_av 
+          ENDIF
+       ELSE
+
+          SELECT CASE ( TRIM( variable(7:) ) )
+
+             CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV', 'g_OCSV' )
+                IF ( TRIM( variable(9:) ) == 'H2SO4' )  THEN  ! 9: remove salsa_g_ from beginning
+                   found_index = 1
+                   to_be_resorted => g_h2so4_av
+                ELSEIF ( TRIM( variable(9:) ) == 'HNO3' )  THEN
+                   found_index = 2
+                   to_be_resorted => g_hno3_av
+                ELSEIF ( TRIM( variable(9:) ) == 'NH3' )  THEN
+                   found_index = 3
+                   to_be_resorted => g_nh3_av
+                ELSEIF ( TRIM( variable(9:) ) == 'OCNV' )  THEN
+                   found_index = 4
+                   to_be_resorted => g_ocnv_av
+                ELSEIF ( TRIM( variable(9:) ) == 'OCSV' )  THEN
+                   found_index = 5
+                   to_be_resorted => g_ocsv_av
+                ENDIF
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
